package esrpatcher;

import javax.swing.ImageIcon;

import util.Utils;

public enum ESRStatus
{
    SUCCESS_PATCH("patched", new ImageIcon(Utils.getImage("resources/img/success.png"))),
    SUCCES_UNPATCH("unpatched", new ImageIcon(Utils.getImage("resources/img/success.png"))),
    WARN_ALREADY_PATCHED("already patched", new ImageIcon(Utils.getImage("resources/img/neutral.png"))),
    WARN_NOT_PATCHED("not patched", new ImageIcon(Utils.getImage("resources/img/neutral.png"))),
    ERROR_NOT_UDF_ISO("no UDF descriptor", new ImageIcon(Utils.getImage("resources/img/error.png"))),
    ERROR_PATCHING("error processing", new ImageIcon(Utils.getImage("resources/img/error.png")));

    private final String message;
    private final ImageIcon icon;

    private ESRStatus(String msg, ImageIcon icn)
    {
        message = msg;
        icon = icn;
    }

    public String getMessage()
    {
        return message;
    }

    public ImageIcon getIcon()
    {
        return icon;
    }
}
