package opl;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;

public class Lang
{
    public static final int _STR_LOCALE                    =   0; // Localized language name
    public static final int _STR_WELCOME                   =   1;
    public static final int _STR_OUL_VER                   =   2;
    public static final int _STR_SAVE_CHANGES              =   3;
    public static final int _STR_O_BACK                    =   4;
    public static final int _STR_IPCONFIG                  =   5;
    public static final int _STR_NO_ITEMS                  =   6;
    public static final int _STR_SETTINGS_SAVED            =   7;
    public static final int _STR_ERROR_SAVING_SETTINGS     =   8;
    public static final int _STR_EXIT                      =   9;
    public static final int _STR_SETTINGS                  =  10;
    public static final int _STR_USB_GAMES                 =  11;
    public static final int _STR_HDD_GAMES                 =  12;
    public static final int _STR_NET_GAMES                 =  13;
    public static final int _STR_APPS                      =  14;
    public static final int _STR_THEME                     =  15;
    public static final int _STR_LANGUAGE                  =  16;
    public static final int _STR_NETWORK_STARTUP_ERROR     =  17;
    public static final int _STR_ON                        =  18;
    public static final int _STR_OFF                       =  19;
    public static final int _STR_OK                        =  20;
    public static final int _STR_COMPAT_SETTINGS           =  21;
    public static final int _STR_REMOVE_ALL_SETTINGS       =  22;
    public static final int _STR_REMOVED_ALL_SETTINGS      =  23;
    public static final int _STR_SCROLLING                 =  24;
    public static final int _STR_SLOW                      =  25;
    public static final int _STR_MEDIUM                    =  26;
    public static final int _STR_FAST                      =  27;
    public static final int _STR_DEFDEVICE                 =  28;
    public static final int _STR_LOAD_FROM_DISC            =  29;
    public static final int _STR_PLEASE_WAIT               =  30;
    public static final int _STR_ERROR_LOADING_ID          =  31;
    public static final int _STR_AUTOSORT                  =  32;
    public static final int _STR_ERR_LOADING_LANGFILE      =  33;
    public static final int _STR_DEBUG                     =  34;
    public static final int _STR_NO_CONTROLLER             =  35;
    public static final int _STR_COVERART                  =  36;
    public static final int _STR_WIDE_SCREEN               =  37;
    public static final int _STR_POWEROFF                  =  38;
    public static final int _STR_LOADING_SETTINGS          =  39;
    public static final int _STR_SAVING_SETTINGS           =  40;
    public static final int _STR_START_DEVICE              =  41;
    public static final int _STR_USBMODE                   =  42;
    public static final int _STR_HDDMODE                   =  43;
    public static final int _STR_ETHMODE                   =  44;
    public static final int _STR_APPMODE                   =  45;
    public static final int _STR_AUTO                      =  46;
    public static final int _STR_MANUAL                    =  47;
    public static final int _STR_STARTHDL                  =  48;
    public static final int _STR_STARTINGHDL               =  49;
    public static final int _STR_RUNNINGHDL                =  50;
    public static final int _STR_STOPHDL                   =  51;
    public static final int _STR_UNLOADHDL                 =  52;
    public static final int _STR_EXITTO                    =  53;
    public static final int _STR_BGCOLOR                   =  54;
    public static final int _STR_TXTCOLOR                  =  55;
    public static final int _STR_IP                        =  56;
    public static final int _STR_MASK                      =  57;
    public static final int _STR_GATEWAY                   =  58;
    public static final int _STR_PORT                      =  59;
    public static final int _STR_SHARE                     =  60;
    public static final int _STR_USER                      =  61;
    public static final int _STR_PASSWORD                  =  62;
    public static final int _STR_NOT_SET                   =  63;
    public static final int _STR_X_ACCEPT                  =  64;
    public static final int _STR_DELETE_WARNING            =  65;
    public static final int _STR_RENAME                    =  66;
    public static final int _STR_DELETE                    =  67;
    public static final int _STR_RUN                       =  68;
    public static final int _STR_GFX_SETTINGS              =  69;
    public static final int _STR_DANDROP                   =  70;
    public static final int _STR_CHECKUSBFRAG              =  71;
    public static final int _STR_LASTPLAYED                =  72;
    public static final int _STR_ERR_FRAGMENTED            =  73;
    public static final int _STR_ERR_FILE_INVALID          =  74;
    public static final int _STR_TEST                      =  75;
    public static final int _STR_HINT_GUEST                =  76;
    public static final int _STR_HINT_MODE1                =  77;
    public static final int _STR_HINT_MODE2                =  78;
    public static final int _STR_HINT_MODE3                =  79;
    public static final int _STR_HINT_MODE4                =  80;
    public static final int _STR_HINT_MODE5                =  81;
    public static final int _STR_HINT_MODE6                =  82;
    public static final int _STR_HINT_MODE7                =  83;
    public static final int _STR_HINT_MODE8                =  84;
    public static final int _STR_HINT_MODE9                =  85;
    public static final int _STR_HINT_VMC_SIZE             =  86;
    public static final int _STR_CREATE                    =  87;
    public static final int _STR_MODIFY                    =  88;
    public static final int _STR_ABORT                     =  89;
    public static final int _STR_RESET                     =  90;
    public static final int _STR_USE_GENERIC               =  91;
    public static final int _STR_VMC_SCREEN                =  92;
    public static final int _STR_VMC_NAME                  =  93;
    public static final int _STR_VMC_SIZE                  =  94;
    public static final int _STR_VMC_STATUS                =  95;
    public static final int _STR_VMC_PROGRESS              =  96;
    public static final int _STR_VMC_FILE_EXISTS           =  97;
    public static final int _STR_VMC_FILE_ERROR            =  98;
    public static final int _STR_VMC_FILE_NEW              =  99;
    public static final int _STR_ERR_VMC_CONTINUE          = 100;
    
    public static final int LANG_STR_COUNT                 = 101;
    
    // Language support
    private static String internalEnglish[] =
    {
        "English (internal)",
        "               WELCOME TO OPEN PS2 LOADER. MAIN CODE BASED ON SOURCE CODE OF HD PROJECT <http://psx-scene.com> ADAPTATION TO USB ADVANCE FORMAT AND INITIAL GUI BY IFCARO <http://ps2dev.ifcaro.net> MOST OF LOADER CORE IS MADE BY JIMMIKAELKAEL. ALL THE GUI IMPROVEMENTS ARE MADE BY VOLCA. THANKS FOR USING OUR PROGRAM ^^",
        "Open PS2 Loader %s",
        "Save changes",
        "O Back",
        "Network config",
        "<no values>",
        "Settings saved...",
        "Error writing settings!",
        "Exit",
        "Settings",
        "USB Games",
        "HDD Games",
        "Network Games",
        "Apps",
        "Theme",
        "Language",
        "Network startup error",
        "On",
        "Off",
        "Ok",
        "Game settings",
        "Remove all settings",
        "Removed all keys for the game",
        "Scrolling",
        "Slow",
        "Medium",
        "Fast",
        "Default menu",
        "Load from disc",
        "Please wait",
        "Error while loading the Game ID",
        "Automatic sorting",
        "Error loading the language file",
        "Disable Debug Colors",
        "No controller detected, waiting...",
        "Enable Cover Art",
        "Wide screen",
        "Power off",
        "Loading config",
        "Saving config",
        "Start device",
        "USB device start mode",
        "HDD device start mode",
        "ETH device start mode",
        "Applications start mode",
        "Auto",
        "Manual",
        "Start HDL Server",
        "HDL Server Starting...",
        "HDL Server Running... Press [O] to stop",
        "Press [X] to terminate HDL server",
        "HDL Server Unloading...",
        "Exit to",
        "Background color",
        "Text color",
        "IP",
        "Mask",
        "Gateway",
        "Port",
        "Share",
        "User",
        "Password",
        "<not set>",
        "X Accept",
        "Item will be permanently deleted, continue ?",
        "Rename",
        "Delete",
        "Run",
        "Display settings",
        "Enable Delete and Rename operations",
        "Check USB game fragmentation",
        "Remember last played game",
        "Error, the game is fragmented",
        "Error, could not run the item",
        "Test",
        "Leave empty for GUEST auth.",
        "Load alt. core",
        "Alternative data read method",
        "Unhook Syscalls",
        "0 PSS mode",
        "Disable DVD-DL",
        "Disable IGR",
        "Reduced cdvdfsv buffer",
        "Hide dev9 module",
        "Alternate IGR combo",
        "Changing the size will reformat the VMC",
        "Create",
        "Modify",
        "Abort",
        "Reset",
        "Use generic",
        "Configure VMC",
        "Name",
        "Size",
        "Status",
        "Progress",
        "VMC file exist",
        "Invalid VMC file, size is incorrect",
        "VMC file need to be created",
        "Error with VMC file, continue with physical MC ?"
    };
    
    private static String lang_strs[] = internalEnglish;
    
    public static String getI18N(int id)
    {
        return lang_strs[id];
    }
    
    public static void lngLoadFromFile(String path)
    {
        if (path != null)
        {
            File fileBuffer = new File(path);
            if (fileBuffer.exists())
            {
                // file exists, try to read it and load the custom lang
                lang_strs = new String[LANG_STR_COUNT];
    
                int strId = 0;
                BufferedReader reader = null;
                try
                {
                    reader = new BufferedReader(new FileReader(fileBuffer));
                    while (strId < LANG_STR_COUNT &&  (lang_strs[strId] = reader.readLine()) != null)
                    {
                        strId++;
                    }
                }
                catch(Exception ex)
                {
                    ex.printStackTrace(System.err);
                }
                finally
                {
                    if (reader != null)
                    {
                        try
                        {
                            reader.close();
                        }
                        catch (Exception ex)
                        {}
                    }
                }
                
                // if necessary complete lang with default internal
                while (strId < LANG_STR_COUNT)
                {
                    lang_strs[strId] = internalEnglish[strId];
                    strId++;
                }
                
                return;
            }
        }
        lang_strs = internalEnglish;
    }
}
